poj2391Ombrophobic Bovines网络流最短路加二分

Language:Default

Ombrophobic Bovines

Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 21569   Accepted: 4638

Description

FJ's cows really hate getting wet so much that the mere thought of getting caught in the rain makes them shake in their hooves. They have decided to put a rain siren on the farm to let them know when rain is approaching. They intend to create a rain evacuation plan so that all the cows can get to shelter before the rain begins. Weather forecasting is not always correct, though. In order to minimize false alarms, they want to sound the siren as late as possible while still giving enough time for all the cows to get to some shelter. 

The farm has F (1 <= F <= 200) fields on which the cows graze. A set of P (1 <= P <= 1500) paths connects them. The paths are wide, so that any number of cows can traverse a path in either direction. 

Some of the farm's fields have rain shelters under which the cows can shield themselves. These shelters are of limited size, so a single shelter might not be able to hold all the cows. Fields are small compared to the paths and require no time for cows to traverse. 

Compute the minimum amount of time before rain starts that the siren must be sounded so that every cow can get to some shelter.

Input

* Line 1: Two space-separated integers: F and P 

* Lines 2..F+1: Two space-separated integers that describe a field. The first integer (range: 0..1000) is the number of cows in that field. The second integer (range: 0..1000) is the number of cows the shelter in that field can hold. Line i+1 describes field i. 

* Lines F+2..F+P+1: Three space-separated integers that describe a path. The first and second integers (both range 1..F) tell the fields connected by the path. The third integer (range: 1..1,000,000,000) is how long any cow takes to traverse it.

Output

* Line 1: The minimum amount of time required for all cows to get under a shelter, presuming they plan their routes optimally. If it not possible for the all the cows to get under a shelter, output "-1".

Sample Input

3 4
7 2
0 4
2 6
1 2 40
3 2 70
2 3 90
1 3 120

Sample Output

110

Hint

OUTPUT DETAILS: 

In 110 time units, two cows from field 1 can get under the shelter in that field, four cows from field 1 can get under the shelter in field 2, and one cow can get to field 3 and join the cows from that field under the shelter in field 3. Although there are other plans that will get all the cows under a shelter, none will do it in fewer than 110 time units.

Source

USACO 2005 March Gold

 给定一个有n个顶点和m条边的无向图,点i 处有Ai头牛,点i 处的牛棚能容纳Bi头牛,每条边有一个时间花费ti(表示从一个端点走到另一个端点所需要的时间),求一个最短时间T使得在T时间内所有的牛都能进到某一牛棚里去。

   将每个点i 拆成两个点i’, i’’,连 边(s, i’, Ai), (i’’, t, Bi)。二分最短时间T,若d[i][j]<=T(d[i][j]表示点i, j 之间的最短时间花费)则加边(i’, j’’,  ∞)。每次根据最大流调整二分的上下界即可。

这里拆点是因为i点有两个属性,一个是现在有多少牛,其次是一共能容纳多少牛,加边时i和i''之间加无穷,因为一个棚可以放多只奶牛

#include<cstdio>
#include<cstring>
#include<queue>
#include<vector>
#include<algorithm>
#define inf 1e9
#define infLL 1LL<<60
using namespace std;
const int maxn=500+10;

struct Edge
{
    int from,to,cap,flow;
    Edge(){}
    Edge(int f,int t,int c,int fl):from(f),to(t),cap(c),flow(fl){}
};

struct Dinic
{
    int n,m,s,t;
    vector<Edge> edges;
    vector<int> G[maxn];
    int d[maxn];
    bool vis[maxn];
    int cur[maxn];

    void init(int n,int s,int t)
    {
        this->n=n,this->s=s,this->t=t;
        edges.clear();
        for(int i=0;i<n;i++) G[i].clear();
    }

    void addedge(int from,int to,int cap)
    {
        edges.push_back( Edge(from,to,cap,0) );
        edges.push_back( Edge(to,from,0,0) );
        m = edges.size();
        G[from].push_back(m-2);
        G[to].push_back(m-1);
    }

    bool BFS()
    {
        queue<int> Q;
        memset(vis,0,sizeof(vis));
        vis[s]=true;
        d[s]=0;
        Q.push(s);
        while(!Q.empty())
        {
            int x=Q.front(); Q.pop();
            for(int i=0;i<G[x].size();i++)
            {
                Edge& e=edges[G[x][i]];
                if(!vis[e.to] && e.cap>e.flow)
                {
                    vis[e.to]=true;
                    d[e.to]=d[x]+1;
                    Q.push(e.to);
                }
            }
        }
        return vis[t];
    }

    int DFS(int x,int a)
    {
        if(x==t || a==0) return a;
        int flow=0,f;
        for(int& i=cur[x];i<G[x].size();i++)
        {
            Edge& e=edges[G[x][i]];
            if(d[e.to]==d[x]+1 && (f=DFS(e.to,min(a,e.cap-e.flow) ) ) >0)
            {
                e.flow+=f;
                edges[G[x][i]^1].flow -=f;
                flow+=f;
                a-=f;
                if(a==0) break;
            }
        }
        return flow;
    }

    int maxflow()
    {
        int ans=0;
        while(BFS())
        {
            memset(cur,0,sizeof(cur));
            ans +=DFS(s,inf);
        }
        return ans;
    }
}Dc;

int n,m;
long long dis[maxn][maxn];
int now[maxn];
int can[maxn];
int fullflow;
void floyd(int n)
{
    for(int k=1;k<=n;k++)
        for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        if(dis[i][k]<infLL&&dis[k][j]<infLL)
        dis[i][j]=min(dis[i][j],dis[i][k]+dis[k][j]);
}
bool solve(long long limit)
{
    Dc.init(2*n+2,0,2*n+1);
    for(int i=1;i<=n;i++)
    {
        Dc.addedge(0,i,now[i]);
        Dc.addedge(i+n,2*n+1,can[i]);
    }
    for(int i=1;i<=n;i++)
for(int j=1;j<=n;j++)
    if(dis[i][j]<=limit)
    Dc.addedge(i,j+n,inf);
return Dc.maxflow()==fullflow;
}
int main()
{
    while(~scanf("%d%d",&n,&m))
    {fullflow=0;
    for(int i=1;i<=n;i++)
        for(int j=1;j<=n;j++)
        dis[i][j]=i==j?0:infLL;
        for(int i=1;i<=n;i++)
            {scanf("%d%d",&now[i],&can[i]);
            fullflow+=now[i];
            }
            int u,v;
            long long w;
        while(m--)
        {
            scanf("%d%d%lld",&u,&v,&w);
            dis[u][v]=dis[v][u]=min(w,dis[u][v]);

        }
        floyd(n);
        long long l=0,r=0;
        for(int i=1;i<=n;i++)
            for(int j=1;j<=n;j++)
            if(dis[i][j]<infLL)
            r=max(r,dis[i][j]);
        if(!solve(r))
            printf("-1\n");
        else
        {
            while(r>l)
            {
                long long mid=l+(r-l)/2;
                if(solve(mid))
                    r=mid;
                else
                    l=mid+1;
            }
            printf("%lld\n",r);
        }
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/sdauguanweihong/article/details/85042070